/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getDoubleOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getDoubleOperationDispatcher. It contains of all the generic methods
    for getDoubleOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getDoubleOperationDispatcher_HXX
#define getDoubleOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getDoubleOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getDoubleOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getDoubleOperationDispatcher();
        virtual ~getDoubleOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getDoublePreConditions( const Teamcenter::BusinessObject* obj, double& doubleValue, bool& isNull ) const;
        void getDoublePreActions( const Teamcenter::BusinessObject* obj, double& doubleValue, bool& isNull ) const;
        void getDoubleBaseAction( const Teamcenter::BusinessObject* obj, double& doubleValue, bool& isNull ) const;
        void getDoublePostActions( const Teamcenter::BusinessObject* obj, double& doubleValue, bool& isNull ) const;

        // Project 011450 changes
        void getDoublePreConditions( METHOD_message_t*  msgData, double* value, logical* isNull ) const;
        void getDoublePreActions( METHOD_message_t*  msgData, double* value, logical* isNull ) const;
        void getDoubleBaseAction( METHOD_message_t*  msgData, double* value, logical* isNull ) const;
        void getDoublePostActions( METHOD_message_t*  msgData, double* value, logical* isNull ) const;

        void getDouble( const Teamcenter::BusinessObject* obj, double& doubleValue, bool& isNull ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getDoubleOperationDispatcher_HXX
